## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1

Name:       stgit
Version:    2.5.3
Release:    %autorelease
Summary:    Stack-based patch management for Git

SourceLicense:    GPL-2.0-only
# (Apache-2.0 OR MIT) AND BSD-3-Clause
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 OR BSL-1.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause OR Apache-2.0 OR MIT
# BSD-3-Clause
# GPL-2.0-only
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# Unicode-3.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        Apache-2.0 AND BSD-3-Clause AND GPL-2.0-only AND MIT AND Unicode-3.0 AND (0BSD OR Apache-2.0 OR MIT) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (BSD-2-Clause OR Apache-2.0 OR MIT) AND (Apache-2.0 OR MIT OR Zlib) AND (MIT OR Unlicense)

URL:        https://stacked-git.github.io/
Source:     https://github.com/stacked-git/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Relax clap dependency to allow building with clap 4.5+
# Relax thiserror dependency
Patch:      stgit-fix-metadata.diff

BuildRequires:  cargo-rpm-macros
BuildRequires:  asciidoc
BuildRequires:  make
BuildRequires:  perl
BuildRequires:  xmlto

%if %{with check}
BuildRequires:  procps-ng
BuildRequires:  git-core
BuildRequires:  git-email
%endif

Requires:   git-core
Requires:   git-email
Requires:   emacs-filesystem
Requires:   vim-filesystem

%description
Stacked Git, StGit for short, is an application for managing Git commits as a
stack of patches.

With a patch stack workflow, multiple patches can be developed concurrently and
efficiently, with each patch focused on a single concern, resulting in both a
clean Git commit history and improved productivity.

%prep
%autosetup -n %{name}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
# The build.rs file only adds an environment variable with the current git
# hash. The tarball is not a git repo so the build script doesn't do anything.
# This also means, it doesn't emit any rerun-if* directives. This makes cargo
# rebuild the whole application if any file changes. This causes frequent
# recompiles in the documentation, etc. leading to very long build times.
rm build.rs
# The Makefile uses some combination of --locked and --offline which only work
# with Cargo.lock present. Regenerating it after cargo_prep should be fine.
%{__cargo} generate-lockfile

make all CARGO="%{__cargo}" STG_PROFILE=rpm
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
make install install-man install-completion install-contrib CARGO="%{__cargo}" STG_PROFILE=rpm DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix}

# Install data files
install -m 644 -D contrib/stgbashprompt.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib/stgbashprompt.sh

%if %{with check}
%check
%cargo_test
# Use the same profile to prevent a rebuild of the application
make test CARGO="%{__cargo}" STG_PROFILE=rpm
%endif

%files
%license COPYING
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc README.md
%{_bindir}/stg
%{_mandir}/man1/stg*
%{_datadir}/%{name}/
%{_datadir}/emacs/site-lisp/stgit.el
%{_datadir}/vim/vimfiles/ftdetect/stg.vim
%{_datadir}/vim/vimfiles/syntax/stg*.vim
%{bash_completions_dir}/stg
%{fish_completions_dir}/stg.fish
%{zsh_completions_dir}/_stg

%changelog
## START: Generated by rpmautospec
* Wed Apr 23 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 2.5.3-1
- Update to version 2.5.3; Fixes RHBZ#2346052

* Wed Jan 22 2025 blinxen <h-k-81@hotmail.com> - 2.5.1-1
- Update to version 2.5.1 (rhbz#2332427)

* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Wed Sep 18 2024 blinxen <h-k-81@hotmail.com> - 2.4.12-1
- Update to version 2.4.12 (rhbz#2301550)

* Tue Jul 23 2024 Felix Maurer <felix@felix-maurer.de> - 2.4.8-1
- Update to v2.4.8 (rhbz#2299433)

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Jul 07 2024 blinxen <h-k-81@hotmail.com> - 2.4.7-2
- Update gix dependency to 0.63

* Thu Jun 20 2024 Felix Maurer <felix@felix-maurer.de> - 2.4.7-1
- Update to 2.4.7 (rhbz#2279302)

* Tue Apr 09 2024 Felix Maurer <felix@felix-maurer.de> - 2.4.6-1
- Update to 2.4.6 (RHBZ#2273964)

* Fri Apr 05 2024 blinxen <h-k-81@hotmail.com> - 2.4.5-1
- Update to version 2.4.5

* Sat Mar 30 2024 Fabio Valentini <decathorpe@gmail.com> - 2.4.0-2
- Relax clap dependency to allow building with clap 4.5+

* Mon Mar 04 2024 Felix Maurer <felix@felix-maurer.de> - 2.4.0-1
- Update to 2.4.0 (RHBZ#2260849)

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 1.5-2
- Rebuilt for Python 3.11

* Mon Feb 21 2022 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.5-1
- resolves: #2047946
  updated to 1.5

* Sat Jan 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Nov 07 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.4-1
- resolves: #2007998
  updated to 1.4

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 1.1-2
- Rebuilt for Python 3.10

* Sat May 29 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.1-1
- resolves: #1955877
  updated to 1.1

* Fri Feb 19 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.0-1
- resolves: #1926050
  updated to 1.0

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.23-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jan 11 2021 Zane Bitter <zbitter@redhat.com> - 0.23-3
- resolves: #1915049
  Fix bash completion

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sun Jun 14 2020 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.23-1
- resolves: #1846723
  updated to 0.23

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 0.22-2
- Rebuilt for Python 3.9

* Wed Mar 11 2020 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.22-1
- resolves: #1811808
  updated to 0.22

* Fri Jan 31 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Nov 20 2019 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.21-1
- resolves: #1766354
  updated to 0.21

* Mon Oct 14 2019 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.20-1
- resolves: #1758807
  updated to 0.20

* Thu Oct 03 2019 Miro Hrončok <mhroncok@redhat.com> - 0.19-4
- Rebuilt for Python 3.8.0rc1 (#1748018)

* Mon Aug 19 2019 Miro Hrončok <mhroncok@redhat.com> - 0.19-3
- Rebuilt for Python 3.8

* Sat Jul 27 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.19-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Jun 05 2019 Dan Horák <dan[at]danny.cz> - 0.19-1
- updated to 0.19
- drop upstreamed patch
- switch to Python3

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Jul 17 2018 Miro Hrončok <mhroncok@redhat.com> - 0.18-4
- Update Python macros to new packaging standards
  (See https://fedoraproject.org/wiki/Changes/Move_usr_bin_python_into_separate_package)

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Nov 24 2017 Peter Schiffer <pschiffe@redhat.com> - 0.18-1
- resolves: #1513726
  updated to 0.18

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17.1-5
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Oct 17 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17.1-1
- resolves: #1014240
  updated to 0.17.1
- resolves: #1004478
  added dependency on git-email package, so the stg mail command
  can function properly

* Wed Jul 31 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-3
- fixed dirty index errors when resolving conflicts

* Tue Jul 30 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-2
- included vim syntax highlighting (thanks to Zane Bitter <zbitter@redhat.com>)

* Thu Jul  4 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-1
- resolves: #979618
  updated to 0.17

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.16-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Dec  4 2012 Peter Schiffer <pschiffe@redhat.com> - 0.16-2
- resolves: #872651
  fixed regression when "stg new" command was ignoring patchdescr.tmpl file

* Mon Oct 22 2012 Peter Schiffer <pschiffe@redhat.com> - 0.16-1
- updated to 0.16

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.14.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Jul 22 2010 David Malcolm <dmalcolm@redhat.com> - 0.14.3-7
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.14.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.14.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Dec 04 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.14.3-4
- Rebuild for Python 2.6

* Tue Dec 02 2008 James Bowes <jbowes@redhat.com> 0.14.3-3
- Try and make the summary text better

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.14.3-2
- Rebuild for Python 2.6

* Tue Jun 17 2008 James Bowes <jbowes@redhat.com> 0.14.3-1
- Update to 0.14.3

* Wed Mar 26 2008 James Bowes <jbowes@redhat.com> 0.14.2-1
- Update to 0.14.2

* Wed Dec 12 2007 James Bowes <jbowes@redhat.com> - 0.14.1-1
- Update to 0.14.1

* Thu Aug 23 2007 James Bowes <jbowes@redhat.com> - 0.13-2
- Mark license as GPLv2+

* Sun Aug 05 2007 James Bowes <jbowes@redhat.com> - 0.13-1
- Update to 0.13

* Wed Apr 25 2007 James Bowes <jbowes@redhat.com> - 0.12.1-2
- Use macro for datadir.

* Thu Apr 19 2007 James Bowes <jbowes@redhat.com> - 0.12.1-1
- Update version.
- Don't install the bash prompt shell script as executable.

* Fri Feb 02 2007 James Bowes <jbowes@redhat.com> - 0.12-1
- Initial packaging.

## END: Generated by rpmautospec
